#!/system/bin/sh

# Tunggu hingga boot selesai
while [ -z "$(getprop sys.boot_completed)" ]; do
    sleep 1
done

# Path untuk pengaturan KCAL
KCAL_PATH="/sys/devices/platform/kcal_ctrl.0"
KCAL_MODULE_PATH="/sys/module/msm_drm/parameters"

# Fungsi untuk menulis nilai ke file sistem
write_value() {
    [ -f "$1" ] && echo "$2" >"$1"
}

# Aktifkan KCAL
if [ -d "$KCAL_PATH" ]; then
    write_value "$KCAL_PATH/kcal_enable" 1
    write_value "$KCAL_PATH/kcal" "255 255 255"
    write_value "$KCAL_PATH/kcal_val" 255
    write_value "$KCAL_PATH/kcal_cont" 255
    write_value "$KCAL_PATH/kcal_sat" 255
elif [ -d "$KCAL_MODULE_PATH" ]; then
    write_value "$KCAL_MODULE_PATH/kcal_enable" 1
    write_value "$KCAL_MODULE_PATH/kcal_red" 255
    write_value "$KCAL_MODULE_PATH/kcal_green" 255
    write_value "$KCAL_MODULE_PATH/kcal_blue" 255
    write_value "$KCAL_MODULE_PATH/kcal_val" 255
    write_value "$KCAL_MODULE_PATH/kcal_cont" 255
    write_value "$KCAL_MODULE_PATH/kcal_sat" 255
fi

# Boost saturasi menggunakan SurfaceFlinger
service call SurfaceFlinger 1023 i32 0
service call SurfaceFlinger 1022 f 1.5

# Loop untuk menyesuaikan KCAL berdasarkan kecerahan layar
while true; do
    BRIGHTNESS=$(settings get system screen_brightness)
    if [ "$BRIGHTNESS" -le 10 ]; then
        write_value "$KCAL_PATH/kcal" "255 255 $((256 - (11 - BRIGHTNESS) * 4))"
    elif [ "$BRIGHTNESS" -ge 47 ]; then
        write_value "$KCAL_PATH/kcal" "$((256 - (BRIGHTNESS - 46))) 255 255"
    else
        write_value "$KCAL_PATH/kcal" "255 255 255"
    fi
    sleep 1
done &

exit 0